# 三、常见非技术性问题及解答

在本章中，我们将讨论非技术性面试问题的主要方面。面试的这一部分通常由招聘经理甚至人力资源人员进行。为这次面试做准备意味着要熟悉以下问题：

*   非技术性问题的目的是什么？
*   你有什么经验？
*   你最喜欢的编程语言是什么？
*   你想做什么？
*   你的职业目标是什么？
*   你的工作风格是什么？
*   你为什么想换工作？
*   你的工资记录是多少？
*   我们为什么要雇用你？
*   你想赚多少钱？
*   你有问题要问我吗？

我们将在各自的特定章节中讨论每个问题。让我们开始吧。

# 非技术性问题的目的是什么？

非技术性面试问题旨在衡量你的经验、性格和个性，以及你适应其他员工和团队的能力之间的匹配程度。**必须适合现有团队**。这些问题也有助于在你和公司之间建立人际关系，并了解他们的理想人选与你的教育、信仰、想法、期望、文化等之间是否存在相容性或化学性。此外，非技术性问题还包括工作的实际和实用方面，如工资、搬迁、医疗保险、工作时间表、加班意愿等。

有些公司会基于这种非技术性面试拒绝应聘者，即使他们最初有意提出报价。

有些公司会在技术面试之前进行面试。这些公司从一开始就试图确定你的经验和目标是否能让你成为该职位的合适人选。这就像说，人的部分比技术部分优先。

其他公司在技术面试结束后举行本次面试。这些公司试图确定什么是对你最好的报价。这就像说技术部分比人的部分优先。

**非技术性问题没有对错答案**！在这种情况下，最好的答案是真诚的回答。根据经验，根据你的感觉回答；不要试图说出面试官想听的话。这就像一场谈判——会有取舍。别忘了礼貌和尊重他人。

此外，让我们看看最常见的非技术性问题和一些回答建议。不要学习/复制这些答案！试着想出你自己的答案，并专注于你想强调的内容。在家里形成并重复答案，在面试官面前做好准备。不要依赖你的自发性；依靠真诚，权衡取舍。

# 你有什么经验？

很可能，在正式介绍之后，你会被问及你的经历。如果你没有为这个问题准备好答案，那么你就有麻烦了。让我们重点介绍几个重要方面，以帮助您准备适当的答案：

*   **不要把你的经历详细列为一张无聊的时间事实清单**：选择最具代表性的项目和成就，热情地谈论它们。热情地谈论你的工作（但不要显得绝望，也不要夸大其词），把你的成就放在团队/项目的背景下。例如，避免说，。。。*我自己做了这个和那个！*还是说*好。。。我通过这样那样做来帮助我的团队。*不要说，*……我是唯一一个有能力做到这一点的人。*更喜欢说*……我被团队提名来完成这项微妙的任务*。如果你是第一份工作，那么谈谈你的学校项目（把你的同事想象成你的团队）和你的独立项目。如果你参加过编程比赛，那么谈谈你的成绩和经验。
*   **不要只强调积极的事情**：经历可以是积极的，也可以是消极的。谈论什么是对的，也谈论什么是错的。大多数时候，真正有价值的教训来自于消极的经历。这些经验迫使我们超越极限去寻找解决方案。此外，这些经历证明了对压力的抵抗力、韧性和专注力。当然，平衡积极和消极的经历，突出你从双方学到的东西。
*   **答案不要太短或太长**：请在 1-2 分钟内校准您的答案。

# 你最喜欢的编程语言是什么？

既然我们谈论的是 Java 的地位，很明显你最喜欢的语言是 Java。但如果出现这样一个问题，那么它意味着揭示您是 Java 上瘾者还是思想开放的人。换句话说，面试官认为很难与沉迷于一种编程语言并希望在所有情况下都只使用它的死板的人一起工作。做 java 开发人员并不意味着你应该考虑 java 来完成所有的任务，而忽略其他所有的事情。所以，一个很好的答案可能是，很明显，我是 java 的忠实粉丝，但我也认为选择最适合的工具是很重要的。认为 Java 是所有问题的答案是荒谬的。

# 你想做什么？

这是一个很难回答的问题，你的答案可能有很多解释。真诚地告诉面试官你到底想做什么。你读了工作描述；因此，你知道你想要这份工作。向面试官解释你做出决定的主要原因。例如，您可以说，*我想成为一名优秀的 Java 后端开发人员，而您的项目在这方面非常具有挑战性。我想成为这些项目团队的一员。*或者，你可以说，*我想成为一家重要公司的重要初创企业的一员，这对我来说是一个很好的机会。我听说一个新的团队正在组建中，我很高兴能成为其中的一员。*别忘了说一些关于在一个伟大的团队中工作的事情！最有可能的是，你不会独自一人工作，而在几乎任何一家公司工作，团队合作都是一个重要方面。

# 你的职业目标是什么？

通过这个问题（或者它的姐妹*你认为自己五年后会在哪里？*，面试官试图看看这个职位是否符合你的职业目标。他们试图了解你是否将这个职位视为你职业道路的一部分，或者你是否有其他原因（除了钱）这样做。很难描述一个详细的职业道路，但你可以给出一个答案，表明你的承诺和动机，把你的工作做好。例如，你可以说，*我目前的目标是作为一名 Java 后端开发人员从事富有挑战性的项目，这将帮助我积累更多的经验。几年来，我看到自己参与了复杂 Java 应用程序的架构。除此之外，现在想都想不起来了。*

# 你的工作风格是什么？

这种问题应该会给你敲响警钟。大多数时候，这个问题都是针对那些工作风格不同寻常的公司提出的。例如，他们经常加班或在周末工作。也许他们轮班工作很长，或者他们有很难达到的指标或期限。或者，他们给这个职位施加了很大的压力和责任。向面试官解释你的工作风格，并间接强调你不同意的地方。例如，你可以指出你不愿意上夜班，你可以这样说：*我喜欢早上开始做最困难的任务，在一天的第二部分，我将处理第二天的计划。*或者，你可以指出，你不愿意在周末工作，你可以说，*我喜欢从周一到周五每周努力工作 40 小时。我喜欢和朋友们一起度过周末。*

如果你被直接问及某个特定方面，那么请给出明确的答案。例如，面试官可能会说，*你知道，如果你在周末工作，你会得到双倍的报酬。你怎么说？*。嗯，三思而后行，按你的感觉回答，但不要留下解释的余地。

# 你为什么想换工作？

当然，如果你是第一份工作，那么你不会遇到这样的问题（或者它的姐妹*你是如何以及为什么离开上一份工作的？*。但是如果你曾经担任过一个角色（或者你计划改变你现在的角色），那么面试官会想知道你为什么做出这个决定。这里的关键是要详细说明清楚而坚实的论点，不要说任何关于你以前的公司、老板、同事等的坏话或冒犯性的话——遵循以下原则*如果你不能对某人说任何好话，就什么都不要说*。

以下是一些可以帮助你回答这个问题的技巧（注意这个问题与上一个问题是如何交叉的——如果这家公司的工作风格与你现在或以前的公司的风格很好地关联，那么很可能离职的原因也同样适用于逃避这份工作）：

*   **不要将金钱作为第一个理由**：金钱通常是换工作的好理由，但将金钱作为第一个理由是一种危险的选择。面试官可能认为你关心的只是钱。或者，他们可能认为你现在的雇主没有提高你的工资，因为你没有足够的价值。他们可能会想，你迟早会想要更多的钱，如果他们不能给你想要的加薪，你会继续寻找其他的方法。
*   **调用一个你无法控制的因素**：调用一个你无法控制的因素会让你处于安全区域。例如，你可以说，*我的团队被分配到一个需要搬迁的项目*。或者，你可以说，*我被感动了。。。上夜班，我无法让我的生活适应这个时间表*。
*   **引发环境的重大变化**：例如，你可以说：*我的公司大规模裁员，我不想冒这个风险*。或者，你可以说，*我在一家小公司工作了 5 年，现在我想把我的经验用在一家大公司*。
*   **引用一个你不喜欢并且面试官知道的方面**：你可以说，*我被聘为 Java 后端程序员，但我花了很多时间帮助前端人员。正如你在我的简历中看到的，我的经验植根于后端技术。*

# 您的薪资历史记录是什么？

显然，这个问题是为了确定新报价的里程碑。如果你对目前的薪水感到满意，那么你可以给出一个数字。否则，最好礼貌地说*我不想把事情搞砸，我希望得到适合新职位及其要求的报酬。*

# 我们为什么要雇用你？

这是一个中肯而又略带冒犯性的问题。在大多数情况下，这是一个陷阱问题，旨在揭示你对批评的反应。如果面试开始时，你应该认为这是一个误导性的问题，你有什么经验？

如果是在面试结束时，那么很明显，面试官非常清楚公司为什么应该雇用你，因此，他不希望听到基于你的简历或经验的有力论据。在这种情况下，保持冷静和积极，并说明为什么你喜欢这家公司，为什么你想在这家公司工作，以及你对它的了解。对面试官来说，表现出你的兴趣（例如，表明你对公司进行了调查并访问了他们的网站）应该是一种奉承，然后面试官可以很快转到下一个问题。

# 你想赚多少钱？

这个问题出现在刚开始的时候（例如，在非技术性的电话屏幕上），或者在最后，当公司准备为您准备报价时。当面试开始时，这意味着面试是否继续将取决于你的回答。如果你的期望超出了潜在的机会，那么面试很可能到此为止。明智的做法是尽可能推迟一个明确的答案，比如说，*我脑子里没有一个明确的数字。当然，钱很重要，但还有其他重要的事情。首先让我们看看我的价值是否符合您的期望，然后我们可以进行谈判。*或者，如果你必须给出答案，那么最好给出一个薪水范围。你应该知道这个职位的一般工资范围（因为你在面试前已经做了家庭作业，并且在互联网上做了调查），因此，提供一个符合你期望并尊重你研究的范围。

理想情况下，这个问题出现在面试过程结束时。这是一个明确的信号，表明公司需要你，并准备向你报价。

现在，你开始谈判的艺术！

别急着说数字！在这一点上，你应该非常清楚你在面试中的表现，以及你多么渴望这份工作。首先，询问面试官提供的工作范围，还有哪些其他奖金，以及总薪酬中包括哪些内容。有几种情况你必须进一步考虑：

*   **在非常愉快的情况下，报价将高于您的期望**：接受它！
*   **更有可能的是，报价接近您的期望**：试着挤出一点。例如，如果你的价格范围在 60000 美元到 65000 美元之间，那么你可以这样说，*我想到了一个非常类似的东西——更准确地说，如果我们可以选择 65000 美元到 70000 美元，我会非常满意。*这可能会帮助您获得大约 63000-68000 美元。
*   **获得回避回答**：你可以得到一个回避回答，而不是一个范围，例如，*我们根据申请人定制工资，因此，我需要知道你的期望。*在这种情况下，请说出您心目中的较高数字。最有可能的是，你不会得到这个提议，但它给了你谈判的空间。简明扼要；例如，比如说，*我预计每年收入 65000 美元。*你应该得到 60000 美元左右，或者一个让你失望的答案，*对不起，但我们考虑的数字要低得多。*这将引出下一节。
*   **Getting a disappointing offer**: In this scenario, try to be very prompt and start by expressing your disappointment like, *I have to say that I am very disappointed with this offer.* Continue by reiterating your strong skills and experience. Try to make clear arguments that support the requested number and underline that you do not want anything outlandish. If you are not open to accepting this job with these conditions, then finish your response with an ultimatum like, *If this is your final word, I cannot accept such an offer.* If the company was impressed by you, it's possible they'd require more time and get back to you with another offer. If you're thinking about accepting the offer, then ask for a written agreement for renegotiation in six months for now. Moreover, try to squeeze other benefits out of the negotations, such as flexible hours, bonuses, and so on.

    重要提示

    根据经验，试着记住以下几个方面：-在谈论薪水时不要害羞或尴尬（新手经常这样做）。-不要从没有谈判空间的低数字开始。-不要低估自己，低估自己。-不要浪费时间谈判不可谈判的事情。

# 你有问题要问我吗？

几乎所有的面试都以这个问题结束。面试官希望澄清你可能存在的任何疑问。你可以问任何你想问的问题，但要注意不要问一些愚蠢的或需要长时间回答的问题。你可以询问面试官所说但不太清楚的事情的细节，也可以询问他们对你的个人看法。或者，你可以问这样的问题，*你是怎么来到这家公司的？对你来说最具挑战性的是什么？*如果你没什么要问的，那就别问了。简单地说，*好吧，我得说你已经回答了我所有重要的问题。谢谢你抽出时间！*。

# 总结

在本章中，我们介绍了您在面试中可能遇到的最常见的非技术性问题。这些问题应该在面试前认真培训，因为它们是成功面试的重要组成部分。诚然，如果没有所需技术知识的坚实证明，这些问题的优秀答案不会单独为你带来工作机会，但它们会影响你的薪水、你的日常工作期望、你的工作风格和职业目标。因此，不要对这样的面试毫无准备。

在下一章中，我们将看到当我们无法获得想要的工作时，如何面对微妙的情况。