# 四、如何处理失败

本章讨论面试中处理失败的一个微妙方面。本章的主要目的是向您展示如何识别故障原因，以及如何在将来缓解故障。

然而，在讨论如何处理失败之前，让我们先快速解决接受或拒绝报价的正确方法。在面试结束时，或面试过程中的某个时刻，你可能会发现自己处于接受或拒绝录用的位置。这不是简单而枯燥的回答是或不是。

本章的议程包括以下内容：

*   接受或拒绝要约
*   考虑到失败是一种选择
*   理解一家公司会因为很多原因拒绝你
*   客观地识别和消除不匹配
*   不会对一家公司产生困扰

让我们从第一个主题开始。

# 接受或拒绝报价

接受报价很简单。你需要通知公司你接受了这份工作，并讨论一些细节，如开始日期（特别是如果你需要在当前工作场所工作一段通知期）、文书工作、重新分配（如果是这样）等等。

拒绝报价是一种更为微妙的情况。它必须以一种让你与每个人保持良好关系的方式来完成。公司在面试中投入了时间和资源，所以你不得不礼貌地拒绝他们的邀请。你也可以在一段时间后再考虑向公司申请。例如，你可以说类似于*的话，我想感谢你的提议。我对贵公司印象深刻，而且我很喜欢面试过程，但我认为这不是我现在的正确选择。再次感谢你，也许有一天我们还会再见面。*

在某些情况下，您需要管理多个报价。当你接受一个提议时，你必须拒绝另一个。在 IT 行业，随着时间的推移，建立联系并保持联系非常重要。人们经常变换工作和职位，在这种动态的环境中，重要的是不要浪费任何联系。因此，不要忘记打电话给给给你的招聘经理（或联系人），告诉他们你的决定。您可以使用前面给出的相同短语。如果你不能打电话，那么发一封电子邮件或亲自去办公室见他们。

# 失败是一种选择

在电影中，我们经常听到“失败不是一种选择”这句话，但那只是电影！面试总是以出价或拒绝告终，所以失败是一种选择。减轻失败是我们的任务。

处理失败并不容易，尤其是当失败接踵而至时。我们每个人对失败的反应都是不同的、人性化的。从感到失望和听天由命到有一种紧张的反应，或者说一些你以后会后悔的话，这些都是正常的人类反应。然而，重要的是你要控制这些反应，并采取专业的行动。这意味着应用一组步骤，在不久的将来减轻故障。首先，理解你被拒绝的原因很重要。

# 一家公司会因为很多原因拒绝你

嗯，也许问题就从这个强有力的词开始：拒绝。说或认为 X 公司拒绝你是正确的吗？我想说的是，这种配方是有毒的，听起来公司对你有个人恩怨。这种思想的形成应该从一开始就被切断。相反，你应该试着找出哪里出了问题。

你是否认为你和公司在技能和/或期望方面存在不匹配？很可能，这更接近现实。面试中有两方（你和面试官），双方都试图确定哪些匹配或兼容性使他们能够以主观的方式进行合作。一旦你这样想，你就不会责怪自己，你会试图找出哪里出了问题。

## 面试后获得反馈

如果公司通知你，你没有被裁掉，是时候给他们打电话，征求他们的反馈了。你可以说*谢谢你采访我。我正在努力提高我的面试技巧，所以如果你能给我提供任何你认为对我有用的反馈，那就太棒了。*

获得适当的反馈非常重要。它代表了修复和消除不匹配的起点，因此您可以开始缓解故障。不匹配通常如下所示：

*   **绩效**：应聘者在面试过程中没有达到或保持预期绩效。
*   **期望**：应聘者没有达到面试官的期望（例如，他们的薪资期望超出了公司的期望）。
*   **缺乏技能**/**经验**：候选人不符合该职位的技能水平（例如，缺乏经验）。
*   **沟通**：应聘者具备技术技能，但表达能力不强。
*   **面试官偏见**：应聘者的行为不适合该职位/公司。

现在让我们看看如何识别和消除不匹配。

# 客观识别并消除不匹配

虽然反馈代表了修复和消除不匹配的起点，但您必须意识到，它可能非常主观。仔细阅读反馈很重要，当你回忆起面试的各个阶段时，用客观的方法将他们的反馈与你的记忆重叠起来。

一旦确定了目标不匹配，就应该消除它们。

# 不要对公司产生迷恋

有些人为了被某家公司雇用而苦苦挣扎。即使经过两三次尝试，他们也不会停止。是继续坚持还是痴迷？他们的理想工作是痴迷还是应该继续尝试？这些都是非常私人的问题，但根据经验，痴迷总是有害的，不会带来任何好处。如果你发现自己处于这种情况下，或者你认识这样的人，那么是时候改变你的态度，并认为以下是正确的思考方式。

# 不要对自己失去信心——有时候，他们配不上你！

这个标题听起来像是一个毫无意义的鼓励口号，旨在让你感觉更好。然而，这不是真的！它总是发生在很多场合。例如，一位歌手在职业生涯初期参加了一场著名的演唱会，却没有赢得任何奖项；她甚至不在那些被认为是好的人中。她没有再次参加比赛（正如在片名中），但几年后，她赢得了她的第一个格莱美奖。

现实生活中有很多这样的例子。这位歌手没有对自己的技巧失去信心，她是对的！那场著名的演唱会配不上她。几年后，演出组织者邀请这位歌手再次演唱（这次是作为嘉宾），组织者为发生的事情道歉。

所以，不要对自己失去信心——有时候，他们配不上你！

# 总结

本章简要概述了求职失败时我们必须明智应对的一个重要方面。它们是生活的一部分，我们必须知道如何以健康和专业的方式处理它们。不要太情绪化，试着对每一次失败都采取专业、冷静、现实和客观的态度。

在下一章中，我们将介绍技术面试的高潮：编码挑战。