# 零、序言

这本书是关于 Java 9 的，Java 9 是最流行的应用程序开发语言之一。最新发布的 Java9 版本提供了大量新功能和新 API，其中包含大量可随时使用的组件，用于构建高效和可扩展的应用程序。流、并行和异步处理、多线程、JSON 支持、反应式编程和微服务构成了现代编程的标志，现在已完全集成到 JDK 中。

因此，如果您希望将 Java 知识提升到另一个层次，并希望提高应用程序的性能，那么您走的是正确的道路。

# 这对我有什么好处？

地图对你的旅行至关重要，尤其是当你在另一个大陆度假时。当涉及到学习时，路线图可以帮助您为实现目标提供明确的前进道路。因此，在您开始旅程之前，这里向您展示了一个路线图。

本书经过精心设计和开发，旨在为您提供有关 Java 的所有正确和相关信息。我们为您创建了此学习路径，包括五个课程：

第 1 课“学习 Java 9 的底层性能改进”，介绍了 Java 9 的激动人心的特性，这些特性将提高应用程序的性能。它关注模块化开发及其对应用程序性能的影响。

第 2 课“提高生产率和加快应用程序的工具”介绍了 Java 9 中添加的两个新工具——JShell 和提前（AOT）编译器，它们可以提高生产率并提高应用程序的整体性能。

第 3 课“多线程和反应式编程”展示了如何使用命令行工具以编程方式监控 Java 应用程序。您还将探索如何通过多线程提高应用程序性能，以及在通过监视了解瓶颈之后如何调优 JVM 本身。

第 4 课“微服务”描述了许多行业领导者在解决负载下的灵活扩展时所采用的解决方案。它讨论了通过将应用程序拆分为几个微服务来添加更多工作人员，每个微服务独立部署，每个微服务使用多线程和反应式编程，以获得更好的性能、响应、可扩展性和容错性。

第 5 课“利用新 API 改进代码”描述了编程工具的改进，包括流过滤器、堆栈遍历 API、创建不可变集合的新的方便静态工厂方法、支持异步处理的新的强大`CompletableFuture`类，以及 JDK9 流 API 的改进。

# 我能从这本书中得到什么？

*   熟悉模块化开发及其对性能的影响
*   了解各种与字符串相关的性能改进，包括压缩字符串和独立字符串连接
*   探索各种底层编译器改进，例如分层属性和提前（AOT）编译
*   了解安全管理器的改进
*   了解图形光栅化器的增强功能
*   使用命令行工具加快应用程序开发
*   了解如何实现多线程和反应式编程
*   在 Java9 中构建微服务
*   实现 API 以改进应用程序代码

# 先决条件

本书面向希望构建可靠和高性能应用程序的 Java 开发人员。开始阅读本书之前需要具备的一些先决条件包括：

*   具备 Java 编程知识