# 零、前言

本书的目的是让读者对 Java 基础知识有一个坚实的理解，引导他们完成从基础到实际编程的一系列实践步骤。讨论和示例旨在激发专业直觉，使用经过验证的编程原则和实践。

完成本书后，您将能够执行以下操作：

*   安装 Java 虚拟机并运行它
*   安装和配置集成开发环境（编辑器）
*   编写、编译和执行 Java 程序和测试
*   了解并使用 Java 语言基础知识
*   理解并应用面向对象的设计原则
*   掌握最常用的 Java 构造

# 这本书是给谁的

目标受众是希望从事现代 Java 编程职业的人，以及希望更新最新 Java 版本知识的中级 Java 程序员新手。

# 这本书涵盖的内容

[第一章](01.html)*计算机上的 Java 虚拟机（JVM）*介绍了 Java 作为一种语言和工具。它描述了 Java 创建的动机、历史、版本、体系结构原则和组件。它还概述了 Java 的市场地位和主要应用领域。然后，一系列实际步骤将引导您完成计算机上 Java 机器的安装和配置过程，以及它的用法和主要命令。

[第 2 章](02.html)*Java 语言基础*介绍了 Java 作为面向对象编程（OOP）语言的基本概念。您将了解类、接口、对象及其关系，以及 OOP 的概念和特性。

[第 3 章](03.html)*您的开发环境设置*解释了什么是开发环境，并指导您进行配置和调优。它还概述了流行的编辑器和构建框架。分步说明帮助读者创建自己的开发环境，并对其进行配置，包括类路径的设置和实际使用。

[第 4 章](04.html)*您的第一个 Java 项目*使用了迄今为止学到的所有知识，并指导读者完成编写程序、开发人员测试和运行程序的过程。

[第 5 章](05.html)*Java 语言元素和类型*，让读者熟悉 Java 语言元素：标识符、变量、文字、关键字、分隔符、注释和类似元素。它还描述了基本类型和引用类型。特别注意类字符串、枚举类型和数组。

[第 6 章](06.html)*接口、类和对象构造*解释了 Java 编程应用程序编程接口（API）、对象工厂、方法重写、隐藏和重载的最重要方面。这里还介绍了 this 和 super 关键字的用法。本章最后讨论了最后的类和方法。

[第 7 章](07.html)、*包和可访问性（可见性）*介绍了包的概念，并教读者如何创建和使用包以提高代码的清晰度。它还描述了类和类成员、方法和属性的不同可访问性级别（可见性）。最后讨论了封装的关键 OOP 设计概念。

[第 8 章](08.html)*面向对象设计（OOD）原则*为 Java 编程提供了更高层次的视角。它讨论了良好设计的标准，并提供了经验证的 OOD 原则指南。它还演示了说明所讨论原则的代码示例。

[第 9 章](09.html)*运算符、表达式和语句*帮助您深入了解 Java 编程的三个核心元素：运算符、表达式和语句。您将看到所有 Java 操作符的列表，了解最流行的操作符的详细信息，并能够执行说明每个操作符的关键方面的特定示例。

[第 10 章](10.html)*控制流语句*描述了允许根据实现算法的逻辑构建程序流的 Java 语句，包括条件语句、迭代语句、分支语句和异常。

[第 11 章](11.html)*JVM 进程和垃圾收集*允许读者在 JVM 的引擎盖下观察，发现它比程序运行程序更复杂。除应用程序线程外，它还执行多个服务线程。其中一个服务线程执行一项重要任务，即从未使用的对象中释放内存。

[第 12 章](12.html)、*Java 标准和外部库*概述了 JDK 中最流行的库和外部库。简短的示例演示了库的功能。本章还指导用户如何在互联网上查找图书馆。

[第 13 章](13.html)、*Java 集合*向您介绍 Java 集合，并通过代码示例演示其用法。

[第 14 章](14.html)*管理集合和数组*向您介绍了允许您创建、初始化和修改集合和数组的类。它们还允许创建不可修改和不可变的集合。其中一些类属于 Java 标准库，另一些属于流行的 Apache Commons 库。

[第 15 章](15.html)*管理对象、字符串、时间和随机数*，展示了 Java 标准库和 Apache Commons 中的类和实用程序，每个程序员都必须掌握这些类和实用程序，才能成为一名有效的程序员。

[第 16 章](16.html)、*数据库编程*解释了如何编写 Java 代码来操作数据库中的插入、读取、更新和删除数据。它还简要介绍了 SQL 语言和基本数据库操作。

[第 17 章](17.html)*Lambda 表达式和函数式编程*解释了函数式编程的概念。它概述了 JDK 附带的函数接口，并解释了如何在 lambda 表达式中使用它们。

[第 18 章](18.html)*流和管道*向读者介绍了强大的数据流处理概念。它解释了什么是流，如何使用 lambda 表达式处理它们，以及如何构建处理管道。它还显示了并行组织流处理是多么容易。

[第 19 章](19.html)、*反应系统*对您未来的专业工作进行了概述和展望。随着越来越多的数据得到处理，服务变得越来越复杂，对更具适应性、高度可扩展性和分布式过程的需求呈指数级增长，这就是我们在本章中将要讨论的，即这样一个软件系统在实践中的表现。

# 充分利用这本书

读者不需要事先了解 Java 编程，尽管了解编程是什么有助于他们充分利用本书。

# 下载示例代码文件

您可以从您的账户[www.packtpub.com](http://www.packtpub.com)下载本书的示例代码文件。如果您在其他地方购买了本书，您可以访问[www.packtpub.com/support](http://www.packtpub.com/support)并注册，将文件通过电子邮件直接发送给您。

通过以下步骤，您可以下载以下文件：

1.  登录或注册[www.packtpub.com](http://www.packtpub.com/support)。
2.  选择“支持”选项卡。
3.  点击代码下载和勘误表。
4.  在搜索框中输入图书名称，然后按照屏幕上的说明进行操作。

下载文件后，请确保使用以下最新版本解压或解压缩文件夹：

*   WinRAR/7-Zip for Windows
*   适用于 Mac 的 Zipeg/iZip/UnRarX
*   适用于 Linux 的 7-Zip/PeaZip

该书的代码包也托管在 GitHub 上的[https://github.com/PacktPublishing/Introduction-to-Programming](https://github.com/PacktPublishing/Introduction-to-Programming) 。我们的丰富书籍和视频目录中还有其他代码包，请访问**[https://github.com/PacktPublishing/](https://github.com/PacktPublishing/)** 。看看他们！

# 下载彩色图像

我们还提供了一个 PDF 文件，其中包含本书中使用的屏幕截图/图表的彩色图像。您可以在这里下载：[https://www.packtpub.com/sites/default/files/downloads/IntroductiontoProgramming_ColorImages.pdf](http://www.packtpub.com/sites/default/files/downloads/IntroductiontoProgramming_ColorImages.pdf) 。

# 使用的惯例

本书中使用了许多文本约定。

`CodeInText`：表示文本中的码字、数据库表名、文件夹名、文件名、文件扩展名、路径名、虚拟 URL、用户输入和 Twitter 句柄。如图 1 所示：“这里是另一个磁盘映像挂载。”

代码块设置如下：

```java
html, body, #map {
 height: 100%; 
 margin: 0;
 padding: 0
}
```

当我们希望提请您注意代码块的特定部分时，相关行或项目以粗体显示：

```java
[default]
exten => s,1,Dial(Zap/1|30)
exten => s,2,Voicemail(u100)
exten => s,102,Voicemail(b100)
exten => i,1,Voicemail(s0)
```

任何命令行输入或输出的编写方式如下：

```java
$ mkdir css
$ cd css
```

**粗体**：表示一个新术语、一个重要单词或您在屏幕上看到的单词。例如，菜单或对话框中的单词出现在文本中，如下所示。下面是一个示例：“从管理面板中选择系统信息。”

警告或重要提示如下所示。

提示和技巧如下所示。

# 联系

我们欢迎读者的反馈。

**一般反馈**：发送电子邮件`feedback@packtpub.com`并在邮件主题中提及书名。如果您对本书的任何方面有疑问，请发送电子邮件至`questions@packtpub.com`。

**勘误表**：尽管我们已尽一切努力确保内容的准确性，但还是会出现错误。如果您在本书中发现错误，如果您能向我们报告，我们将不胜感激。请访问[www.packtpub.com/submit-errata](http://www.packtpub.com/submit-errata)，选择您的书籍，点击 errata 提交表单链接，然后输入详细信息。

**盗版**：如果您在互联网上发现我们作品的任何形式的非法复制品，请您提供我们的位置地址或网站名称，我们将不胜感激。请通过`copyright@packtpub.com`与我们联系，并提供该材料的链接。

**如果您有兴趣成为一名作家**：如果您对某个主题有专业知识，并且您有兴趣撰写或贡献一本书，请访问[authors.packtpub.com](http://authors.packtpub.com/)。

# 评论

请留下评论。一旦你阅读并使用了这本书，为什么不在你购买它的网站上留下评论呢？然后，潜在读者可以看到并使用您的无偏见意见做出购买决定，我们 Packt 可以了解您对我们产品的看法，我们的作者可以看到您对他们书籍的反馈。非常感谢。

有关 Packt 的更多信息，请访问[packtpub.com](https://www.packtpub.com/)。