# 零、前言

无论这是您第一次涉足 Java 等高级面向对象编程语言，还是您已经进行了一段时间的编程，只是想将 Java 添加到您的曲目中，或者即使您一生中从未接触过一行代码，本书都是为您而设计的。我们将快速行动，我们不会回避繁重的主题，但我们将从非常基础的开始这本书，并学习面向对象编程背后的概念。java，如果它能帮助您理解 Java 编程是什么，为什么它是重要的，那么我会认为这本书是成功的。以及如何开始在 NetBeans 中开发 Java 应用程序。如果 Java 成为你最喜欢的编程语言，我也会很高兴！

# 这本书你需要什么

对于本书，您需要一个**Java 开发工具包**（**JDK**和 NetBeans

# 这本书是给谁的

本书适用于任何想要开始学习 Java 语言的人，无论您是学生、临时学习者，还是希望向技能集中添加新语言的现有程序员。没有 Java 或一般编程的经验是必需的。

# 习俗

在本书中，您将发现许多文本样式可以区分不同类型的信息。下面是这些风格的一些例子，并解释了它们的含义。

文本中的代码字、数据库表名、文件夹名、文件名、文件扩展名、路径名、虚拟 URL、用户输入和 Twitter 句柄如下所示：“我们将在`Source Packages`文件中编写代码。”

代码块设置如下：

```java
public class HelloWorld {
    public static void main(String[] args) {
        System.out.println("Hello World!");
    }
}
```

当我们希望提请您注意代码块的特定部分时，相关行或项目以粗体显示：

```java
public class HelloWorld {
    public static void main(String[] args) {
        System.out.println("Hello World!");
    }
}
```

任何命令行输入或输出的编写方式如下：

```java
java -jar WritingToFiles.jar
```

新术语和重要词语以粗体显示。您在屏幕上（例如，在菜单或对话框中）看到的单词出现在如下文本中：“选择 JavaSE 列下面的下载按钮。”

警告或重要注释显示在这样的框中。

提示和技巧如下所示。

# 读者反馈

我们欢迎读者的反馈。让我们知道你对这本书的看法你喜欢或可能不喜欢什么。读者反馈对于我们开发您真正从中获益最多的标题非常重要。

要向我们发送一般反馈，只需向`feedback@packtpub.com`发送电子邮件，并通过邮件主题提及书名即可。

如果您对某个主题有专业知识，并且您有兴趣撰写或贡献一本书，请参阅我们的作者指南，网址为[www.packtpub.com/authors](http://www.packtpub.com/authors)。

# 客户支持

既然您是一本 Packt 图书的骄傲拥有者，我们有很多东西可以帮助您从购买中获得最大收益。

# 下载示例代码

您可以从您的账户[下载示例代码文件 http://www.packtpub.com](http://www.packtpub.com) 对于您购买的所有 Packt 出版书籍。如果您在其他地方购买了本书，您可以访问[http://www.packtpub.com/support](http://www.packtpub.com/support) 并注册，将文件直接通过电子邮件发送给您。通过以下步骤，您可以下载以下文件：

1.  使用您的电子邮件地址和密码登录或注册我们的网站。
2.  将鼠标指针悬停在顶部的“支持”选项卡上。
3.  点击代码下载和勘误表。
4.  在搜索框中输入图书的名称。
5.  选择要下载代码文件的书籍。
6.  从您购买本书的下拉菜单中选择。
7.  点击代码下载。

下载文件后，请确保使用以下最新版本解压或解压缩文件夹：

*   WinRAR/7-Zip for Windows
*   适用于 Mac 的 Zipeg/iZip/UnRarX
*   适用于 Linux 的 7-Zip/PeaZip

该书的代码包也托管在 GitHub 上的[https://github.com/PacktPublishing/Java-Programming-for-Beginners](https://github.com/PacktPublishing/Java-Programming-for-Beginners) 。我们在[上还提供了丰富的书籍和视频目录中的其他代码包 https://github.com/PacktPublishing/](https://github.com/PacktPublishing/) 。看看他们！

# 下载本书的彩色图像

我们还为您提供了一个 PDF 文件，其中包含本书中使用的屏幕截图/图表的彩色图像。彩色图像将帮助您更好地了解输出中的更改。您可以从[下载此文件 https://www.packtpub.com/sites/default/files/downloads/JavaProgrammingforBeginners_ColorImages.pdf](https://www.packtpub.com/sites/default/files/downloads/JavaProgrammingforBeginners_ColorImages.pdf) 。

# 勘误表

虽然我们已尽一切努力确保内容的准确性，但错误确实会发生。如果您在我们的一本书中发现错误，可能是文本或代码中的错误，如果您能向我们报告，我们将不胜感激。通过这样做，您可以使其他读者免于沮丧，并帮助我们改进本书的后续版本。如果您发现任何错误，请访问[进行报告 http://www.packtpub.com/submit-errata](http://www.packtpub.com/submit-errata) ，选择您的书籍，点击勘误表提交表单链接，然后输入勘误表的详细信息。一旦您的勘误表得到验证，您的提交将被接受，勘误表将上载到我们的网站或添加到该标题勘误表部分下的任何现有勘误表列表中。

要查看之前提交的勘误表，请转至[https://www.packtpub.com/books/content/support](https://www.packtpub.com/books/content/support) 并在搜索字段中输入图书名称。所需信息将出现在勘误表部分下。

# 盗版行为

在互联网上盗版版权材料是所有媒体的一个持续问题。在 Packt，我们非常重视版权和许可证的保护。如果您在互联网上发现我们作品的任何形式的非法复制品，请立即向我们提供地址或网站名称，以便我们采取补救措施。

请致电`copyright@packtpub.com`与我们联系，并提供可疑盗版材料的链接。

我们感谢您在保护我们的作者方面的帮助，以及我们为您带来有价值内容的能力。

# 问题

如果您对本书的任何方面有疑问，请致电`questions@packtpub.com`与我们联系，我们将尽力解决。