# 零、序言

# 这本书涵盖的内容

本书深入探讨了 lambdas 及其支持特性；比如函数接口和类型推断。

阅读本书后，您将：

*   概述现代 Java 中的新功能
*   深入了解 lambda、它们的背景、语法、实现细节以及如何以及何时使用它们
*   理解函数与类之间的区别，以及为什么这与 lambdas 相关
*   理解 lambda 和闭包之间的区别
*   欣赏驱动许多新特性的类型推断的改进
*   能够使用方法参考，理解范围界定和“有效最终”
*   了解使用 lambdas 时产生的字节码的差异
*   在使用 lambdas 时，能够解释异常和异常处理最佳实践

# 这本书你需要什么

最新版本的 JDK 和文本编辑器或 IDE。

# 这本书是给谁的

无论您是将遗留 Java 程序迁移到更现代的 Java 风格，还是从头开始构建应用程序，本书都将帮助您开始利用 Java 平台上函数式编程的强大功能。

# 公约

在本书中，您将发现许多文本样式可以区分不同类型的信息。下面是这些风格的一些例子，并解释了它们的含义。

文本中的代码字、数据库表名、文件夹名、文件名、文件扩展名、路径名、虚拟 URL、用户输入和 Twitter 句柄如下所示：“此 LISP 表达式的计算结果为一个函数，当应用该表达式时，将取单个参数，将其绑定到`arg`，然后将`1`添加到其中。”

代码块设置如下：

```java
void anonymousClass() {
    final Server server = new HttpServer();
    waitFor(new Condition() {
        @Override
        public Boolean isSatisfied() {
            return !server.isRunning();
        }
    });
}
```

当我们希望提请您注意代码块的特定部分时，相关行或项目以粗体显示：

```java
void anonymousClass() {
    final Server server = new HttpServer();
    waitFor(new Condition() {
        @Override
        public Boolean isSatisfied() {
            return !server.isRunning();
        }
    });
}
```

**新术语**和**重要词语**以粗体显示。您在屏幕上看到的文字（例如，在菜单或对话框中）会出现如下文本：“为了下载新模块，我们将转到**文件****设置****项目名称****项目解释器**。”

### 注

警告或重要注释显示在这样的框中。

### 提示

提示和技巧如下所示。

# 读者反馈

我们欢迎读者的反馈。让我们知道你对这本书的看法你喜欢还是不喜欢。读者反馈对我们来说很重要，因为它可以帮助我们开发出您将真正从中获得最大收益的标题。要向我们发送一般反馈，只需发送电子邮件 feedback@packtpub.com，并在邮件主题中提及该书的标题。如果您对某个主题有专业知识，并且您有兴趣撰写或贡献一本书，请参阅我们的作者指南[www.packtpub.com/authors](http://www.packtpub.com/authors)。

# 客户支持

既然您是一本 Packt 图书的骄傲拥有者，我们有很多东西可以帮助您从购买中获得最大收益。

## 下载本书彩色图片

我们还为您提供了一个 PDF 文件，其中包含本书中使用的屏幕截图/图表的彩色图像。彩色图像将帮助您更好地了解输出中的更改。您可以从[下载此文件 https://www.packtpub.com/sites/default/files/downloads/LearningJavaLambdas_ColorImages.pdf](https://www.packtpub.com/sites/default/files/downloads/LearningJavaLambdas_ColorImages.pdf) 。

## 勘误表

虽然我们已尽一切努力确保内容的准确性，但错误确实会发生。如果您在我们的一本书中发现错误，可能是文本或代码中的错误，如果您能向我们报告，我们将不胜感激。通过这样做，您可以使其他读者免于沮丧，并帮助我们改进本书的后续版本。如果您发现任何错误，请访问[进行报告 http://www.packtpub.com/submit-errata](http://www.packtpub.com/submit-errata) ，选择您的书籍，点击**勘误表提交表**链接，输入您勘误表的详细信息。一旦您的勘误表得到验证，您的提交将被接受，勘误表将上载到我们的网站或添加到该标题勘误表部分下的任何现有勘误表列表中。

要查看之前提交的勘误表，请转至[https://www.packtpub.com/books/content/support](https://www.packtpub.com/books/content/support) 并在搜索字段中输入图书名称。所需信息将出现在**勘误表**部分下。

## 盗版

在互联网上盗版版权材料是所有媒体都面临的一个持续问题。在 Packt，我们非常重视版权和许可证的保护。如果您在互联网上发现任何形式的非法复制品，请立即向我们提供地址或网站名称，以便我们采取补救措施。

请联系我们 copyright@packtpub.com 与怀疑盗版材料的链接。

我们感谢您在保护我们的作者方面提供的帮助以及我们为您带来有价值内容的能力。

## 问题

如果您对本书的任何方面有疑问，请联系我们 questions@packtpub.com，我们会尽力解决这个问题。