# 零、前言

测试驱动开发已经有一段时间了，很多人还没有采用它。这背后的原因是 TDD 很难掌握。尽管这个理论很容易掌握，但要真正精通它需要大量的实践。本书的作者多年来一直在实践 TDD，并将尝试将他们的经验传授给您。他们是开发人员，相信学习一些编码实践的最佳方法是通过编码和不断的实践。这本书遵循同样的哲学。我们将通过练习解释所有 TDD 概念。这将是一次应用于 Java 开发的 TDD 最佳实践之旅。最后，您将获得一个 TDD 黑带，并且在您的软件工艺工具带中还有一个工具。

# 这本书是给谁的

如果您是一名经验丰富的 Java 开发人员，并且希望实现更有效的系统和应用程序编程方法，那么本书适合您。

# 充分利用这本书

本书中的练习要求读者拥有 64 位计算机。本书提供了所有必需软件的安装说明。

# 下载示例代码文件

您可以从您的账户[www.packtpub.com](http://www.packtpub.com)下载本书的示例代码文件。如果您在其他地方购买了本书，您可以访问[这里](http://www.packtpub.com/support)并注册，将文件通过电子邮件直接发送给您。

您可以通过以下步骤下载代码文件：

1.  登录或注册[www.packtpub.com](http://www.packtpub.com/support)。
2.  选择“支持”选项卡。
3.  点击代码下载和勘误表。
4.  在搜索框中输入图书名称，然后按照屏幕上的说明进行操作。

下载文件后，请确保使用以下最新版本解压或解压缩文件夹：

*   WinRAR/7-Zip for Windows
*   适用于 Mac 的 Zipeg/iZip/UnRarX
*   适用于 Linux 的 7-Zip/PeaZip

该书的代码包也托管[在 GitHub 上](https://github.com/PacktPublishing/Test-Driven-Java-Development-Second-Edition)。如果代码有更新，它将在现有 GitHub 存储库中更新。

我们的丰富书籍和视频目录中还有其他代码包，请访问[这里](https://github.com/PacktPublishing/)。看看他们！

# 下载彩色图像

我们还提供了一个 PDF 文件，其中包含本书中使用的屏幕截图/图表的彩色图像。[您可以在这里下载](https://www.packtpub.com/sites/default/files/downloads/TestDrivenJavaDevelopmentSecondEdition_ColorImages.pdf)。

# 使用的惯例

本书中使用了许多文本约定。

`CodeInText`：表示文本中的码字、数据库表名、文件夹名、文件名、文件扩展名、路径名、虚拟 URL、用户输入和 Twitter 句柄。下面是一个例子：“在这个测试中，我们定义在调用`ticTacToe.play(5, 2)`方法时需要`RuntimeException`

代码块设置如下：

```java
public class FooTest {
  @Rule
  public ExpectedException exception = ExpectedException.none();
  @Test
  public void whenDoFooThenThrowRuntimeException() {
    Foo foo = new Foo();
    exception.expect(RuntimeException.class);
    foo.doFoo();
  }
}
```

任何命令行输入或输出的编写方式如下：

```java
    $ gradle test
```

**粗体**：表示一个新术语、一个重要单词或您在屏幕上看到的单词。例如，菜单或对话框中的单词出现在文本中，如下所示。这里有一个例子：“IntelliJ IDEA 提供了一个非常好的 Gradle 任务模型，可以通过点击查看|工具窗口| Gradle 来实现。”

警告或重要提示如下所示。

提示和技巧如下所示。